import java.io.*;

public class KeyTools {

  /** Die Klasse soll nicht instantiierbar sein -- deshalb machen wir den
   Konstruktor privat */
  private KeyTools(){}

  /** Ferner brauchen wir noch einen BufferedReader, aus dem wir einlesen
   koennen */
  private static BufferedReader in=new BufferedReader
                                       (new InputStreamReader(System.in));

  /** Liest eine Textzeile von der Tastatur ein */
  private static String readLine() {
    // Packe die alte Methode in einen try-Block
    try {
      return in.readLine();
    }
    // und falls eine IOException auftritt
    catch (IOException ex) {
      // so erzeuge eine neue InputException
      InputException ex2=new InputException("");
      // und wirf dieses Objekt
      throw ex2;
    }
  }

  /** Liest einen Double-Wert von der Tastatur ein */
  public static double readDouble() {
    while(true) {
      try {
        return (new Double(readLine())).doubleValue();
      }
      catch (NumberFormatException ex) {}
    }
  }
  
}
